AUTO_DISMOUNT_FORM_CANCEL = true;

SLASH_AUTODISMOUNTFORM1 = "/autodismountform";
SlashCmdList["AUTODISMOUNTFORM"] = function(msg)
    if (AUTO_DISMOUNT_FORM_CANCEL) then
        AUTO_DISMOUNT_FORM_CANCEL = false;
        print("auto dismount form disabled");
    else
        AUTO_DISMOUNT_FORM_CANCEL = true;
        print("auto dismount form enabled");
    end
end

local ErrorsToCheckFor = {
    SPELL_FAILED_NOT_SHAPESHIFT,
    SPELL_FAILED_NO_ITEMS_WHILE_SHAPESHIFTED,
    SPELL_NOT_SHAPESHIFTED,
    SPELL_NOT_SHAPESHIFTED_NOSPACE,
    ERR_CANT_INTERACT_SHAPESHIFTED,
    ERR_NOT_WHILE_SHAPESHIFTED,
    ERR_NO_ITEMS_WHILE_SHAPESHIFTED,
    ERR_TAXIPLAYERSHAPESHIFTED,
    ERR_MOUNT_SHAPESHIFTED,
    ERR_EMBLEMERROR_NOTABARDGEOSET,
    SPELL_FAILED_NOT_MOUNTED,
    ERR_ATTACK_MOUNTED,
    ERR_NOT_WHILE_MOUNTED,
};

local ErrorsTBCExtra = {
	ERR_NO_ATTACK_TARGET,
    ERR_GENERIC_NO_TARGET,
}

local SHAMAN_FORM = 136095; -- spirit wolf

local BuffsToCheckFor = {
    132276, -- bear form
    132115, -- cat form
    132144, -- travel form
    132112, -- aquatic form
	236156, -- improved moonkin
	132128, -- flight
	236157, -- improved tree,
	136036, -- moonkin
	132129, -- tree
};

local TOTAL_BUFFS = 40;

local function TryAndRemoveForms()
    for i = 1, TOTAL_BUFFS do
        local _, currBuffTex = UnitBuff("player", i);
        if (currBuffTex) then
            if (currBuffTex == SHAMAN_FORM) then
                if (not InCombatLockdown()) then
                    CancelUnitBuff("player", i);
                end
                return;
            elseif (tContains(BuffsToCheckFor, currBuffTex)) then
                if (not InCombatLockdown() and AUTO_DISMOUNT_FORM_CANCEL) then
                    local uiScale, x, y = UIParent:GetEffectiveScale(), GetCursorPosition()
                    AutoDismountFormCancel:SetPoint("BOTTOMLEFT", x / uiScale - 64, y / uiScale - 64);
                    AutoDismountFormCancel:Show();
                end
                return;
            end
        else
            -- exit as we reached the end of active buffs
            return;
        end
    end
end

function TryAndDismount(msg, self)
	local _, class = UnitClass("player");
	
	if (class == "DRUID" and
		msg and tContains(ErrorsToCheckFor, msg)) then
		
		if (UIErrorsFrame) then
			UIErrorsFrame:Clear();
		end
	   
		Dismount();
		TryAndRemoveForms();
	elseif (msg and not IsFlying() 
            and (tContains(ErrorsToCheckFor, msg) or tContains(ErrorsTBCExtra, msg))) then
		
		if (UIErrorsFrame) then
            UIErrorsFrame:Clear();
        end
		
		Dismount();
		TryAndRemoveForms();
	end
end